//Version: 0.0.0
//Intended for integration with brick packs.

//Author: Queuenard (ID: 39617)
//Purpose: allows you to create a cuboid brick datablock with a simple function call.
//         The BLB file and datablock are automatically generated from the given dimensions.

//Examples:

//         (creates a standard brick with a uiname, category, subcategory and dimensions)
//         createStandardBrick("48x48x6", "Bricks", "48x", 48,48,6);]

//         (creates a standard brick with a custom datablock name, uiname, category, subcategory and dimensions)
//         createStandardBrickDBName("brickWhateverData", "48x48x6", "Bricks", "48x", 48,48,6);

//If the Z size is 3, the generated datablock name is shortened to exclude the Z field


if($resource_create_standard_brick_version > 0)
	return;

$resource_create_standard_brick_version = 0;

function createStandardBrickDBName(%dbName, %uiName, %category, %subcategory, %dimX, %dimY, %dimZ)
{
	%dimX = mFloatLength(%dimX, 0);
	%dimY = mFloatLength(%dimY, 0);
	%dimZ = mFloatLength(%dimZ, 0);
	%dimensions = %dimX @"x"@ %dimY @"x"@ %dimZ;

	//automatically determined
	%brickFile = "base/server/generated_bricks/auto_"@ %dimensions @".blb";

	%fo = new FileObject();
	%fo.openForWrite(%brickFile);
	%fo.writeLine(%dimX @" "@ %dimY @" "@ %dimZ);
	%fo.writeLine("BRICK");
	%fo.close();
	%fo.delete();

	%command = "datablock fxDTSBrickData("@ %dbName @") { brickFile = \""@ %brickfile @"\"; };";
	eval(%command);

	if(!isObject(%dbname))
		return;

	%dbname.uiname = %uiName;
	%dbname.category = %category;
	%dbname.subcategory = %subcategory;
}

function createStandardBrick(%uiName, %category, %subcategory, %dimX, %dimY, %dimZ)
{
	%dimX = mFloatLength(%dimX, 0);
	%dimY = mFloatLength(%dimY, 0);
	%dimZ = mFloatLength(%dimZ, 0);
	%dimensions = %dimX @"x"@ %dimY @"x"@ %dimZ;

	if(%dimZ == 3)
		%dbName = "brick"@ %dimX @"x"@ %dimY @"Data";

	else
		%dbName = "brick"@ %dimensions @"Data";

	return createStandardBrickDBName(%dbName, %uiName, %category, %subcategory, %dimX, %dimY, %dimZ);
}